/*
 *  $Id: ctc.h,v 1.1.1.1 1998/01/11 00:00:37 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of KCemu, the KC 85/4 Emulator.
 */

#ifndef __kc_ctc_h
#define __kc_ctc_h

#include "kc/kc.h"

class CTC
{
  private:
    const int IRQ_ENABLED = 0x80;
    const int WAIT_FOR_TV = 0x04;
    const int DO_RESET    = 0x02;

    const int MAX_STATE = 9;
    const int MAX_KEYS  = 20;

    byte_t _state;
    byte_t _buf[MAX_STATE];

    byte_t _keys[MAX_KEYS];
    byte_t _first_key, _last_key;

    byte_t _irq_vector;
    byte_t _control[4];
    byte_t _value[4];
    byte_t _timer_value[4];
    byte_t _restart[4];

  public:
    CTC(void);
    void keyPressed(int key);
    byte_t checkInt(void);

    byte_t in(byte_t channel);
    void out(byte_t channel, byte_t val);
};

#endif /* __kc_ctc_h */

