/*
 *  $Id: ui_xwin.h,v 1.1.1.1 1998/01/11 00:00:37 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of KCemu, the KC 85/4 Emulator.
 */

#ifndef __ui_ui_xwin_h
#define __ui_ui_xwin_h

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/extensions/XShm.h>

#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>

#include "ui/ui.h"

class UI_XWin : public UI
{
  private:
    const char WINDOW_NAME[] = "KC 85/4 Emulator";
    const char ICON_NAME[]   = "KC 85/4";

    Display         *_disp;
    Window           _w;
    Atom             _wm_delete_window;
    int              _screen;
    XEvent           _event;
    GC               _black_gc;
    GC               _white_gc;
    XImage          *_img;
    XVisualInfo      _visualInfo;
    XShmSegmentInfo  _shminfo;
    int              _use_shm;
    char            *_bufmem;
    long             _buflen;

    int              _visual_class;   /*             */
    int              _bitdepth;       /* visual info */
    int              _pixbytes;       /*             */

    int              _shift;          /*                   */
    int              _pending_key;    /* keyboard handling */

    bool             _dirty;
    char            *_pix_mem;
    char            *_col_mem;
    unsigned long    _col[24];

  protected:
    void handleKeyPress(XEvent *event);
    void handleKeyRelease(XEvent *event);
    
  public:
    UI_XWin(void);

    void update(bool force_update);
    void putPixel(int x, int y, char val);
    void putColor(int x, int y, char val);
    void processEvents(void);
};

#endif /* __ui_ui_xwin_h */
